import fullscreen.*;
//SoftFullScreen       _fullScreen;
// Bildschirmabmessungen
//long max_x=screen.width;
//long max_y=screen.height;
int max_x=640;
int max_y=480;

// Abmessungen
int schlaeger_hoehe=int(max_y/8);
int schlaeger_breite=int(max_x/128);
int schriftgroesse=max_y/16;

// Koordinaten und Geschwindigkeiten des Balles

float x = 0;
float y = 0;
int ball_radius=max_x/64;
int z=0;
float vstart=max_x/128;

float vx = vstart;
float vy = vstart;

int modus=0;
int[] sy=new int[2];
int[] svy={max_x/64,max_x/64};
int[] leben={5,5};
boolean[] k=new boolean[526];
// --------------------------------------------------------
// Setup, also Erstellen des Programmfensters
void setup() {
  size(640,480);
  // FULLSCREEN
  //_fullScreen = new SoftFullScreen(this);
  //_fullScreen.enter();
  smooth(); frameRate(30);
  textFont(createFont("SansSerif",schriftgroesse));
  textAlign(CENTER);
 
}
// --------------------------------------------------------
// Hauptfunktion
void draw() {
 background(0);
 if (modus==0){
  ball();
  schlaeger();
  zeige_leben();
 } else {
   startmeldung();
 }
}
// --------------------------------------------------------
// Funktion, für die Start- und Endmeldungen
void startmeldung() {
  if ( k[32] ) {
    modus=0;
    leben[0]=5;
    leben[1]=5;
  }
  if (leben[0]==0) {
    fill(0,255,0);
    text("Spieler 2 hat gewonnen", width/2, height/2);
  }
  if (leben[1]==0) {
    fill(255,0,0);
    text("Spieler 1 hat gewonnen", width/2, height/2);
  }
  fill(255,255,255);
  text("Zum Starten Leertaste drücken!", width/2, height-5);
}
// --------------------------------------------------------
// Funktion, um beim Spielen die zahl der Leben anzuzeigen
void zeige_leben() {
  fill(0,255,0);
  text(leben[1], 3*width/4, max_y/8);
  fill(255,0,0);
  text(leben[0], 1*width/4, max_y/8);
}

// --------------------------------------------------------
// Funktion, in der die Bewegung des Balls stattfindet
void ball() {
 fill(0,0,255); stroke(0,0,255);
 ellipse(x,y,2*ball_radius,2*ball_radius);
 // y-Bewegung
 y=y+vy;
 if (y>height-ball_radius) { y=height-ball_radius; vy=-abs(vy); }
 if (y < ball_radius ) { y=ball_radius; vy=abs(vy);}
 // x-Bewegung
 x=x+vx;
 if (x > width-ball_radius) {
 if ( y > sy[1] && y < sy[1]+schlaeger_hoehe ) { x=width-ball_radius; vx=-abs(vx); } 
 else {
   x=ball_radius; vx=vstart; vy=vstart; 
   leben[1]--;
   if (leben[1]==0) {
     modus=1;
   }
 }
 }
 if (x < ball_radius ){
 if ( y > sy[0] && y < sy[0]+schlaeger_hoehe ) { x=ball_radius; vx=abs(vx); }
 else {
   x=width-ball_radius; vx=-vstart;vy=vstart;
   leben[0]--;
   if (leben[0]==0) {
     modus=1;
   }
 }
 }
 // Den Ball beschleunigen
 z++;
 if (z>90) {
 vx*=1.1;
 vy*=1.1;
 z=0;
 }
}
// --------------------------------------------------------
// Funktion, die die Steuerung der Schläger übernimmt
void schlaeger () {
 if (k[65]) { sy[0]+=-svy[0]; }
 if (k[89]) { sy[0]+=+svy[0]; }
 if (k[75]) { sy[1]+=-svy[1]; }
 if (k[77]) { sy[1]+=+svy[1]; }
 for (int i=0;i < 2;i++) {
 if (sy[i] < 0) { sy[i]=0; }
 if (sy[i] > height-schlaeger_hoehe) { sy[i]=height-schlaeger_hoehe; }
 }
 fill(255,0,0); stroke(255,0,0);
 rect(0 ,sy[0],schlaeger_breite,schlaeger_hoehe);
 fill(0,255,0); stroke(0,255,0);
 rect(width-schlaeger_breite-1,sy[1],schlaeger_breite,schlaeger_hoehe);
}
// --------------------------------------------------------
// Hilfsfunktionen, hier Tastaturabfragen
void keyPressed() { k[keyCode]=true; }
void keyReleased() { k[keyCode]=false;}

